<template>
    <div class="q-gutter-sm relative-position" style="position:relative !important;">
        <div class="row">
            <croppa
                :initial-image="image"
                v-model="croppa"
                :placeholder="placeholder"
                :show-remove-button="false"
                :disable-drag-to-move="disableInteraction"
                :disable-scroll-to-zoom="disableInteraction"
                :disable-pinch-to-zoom="disableInteraction"
                :width="w"
                :height="h"
                @new-image="onUpdate"
                @image-remove="onUpdate"
                @loading-end="onUpdate"
            />
        </div>
        <div class="row q-gutter-lg-lg q-gutter-md justify-center items-center">
            <q-btn flat round color="primary" icon="redo" @click="croppa.rotate()" size="12px">
                <q-tooltip>
                    Rotate Image Clockwise 90°
                </q-tooltip>
            </q-btn>
            <q-btn q-btn flat round color="primary" icon="undo" @click="croppa.rotate(-1)" size="12px">
                <q-tooltip>
                    Rotate Image Anti-Clockwise 90°
                </q-tooltip>
            </q-btn>
            <q-btn q-btn flat round color="primary" icon="swap_horiz" @click="croppa.flipX()" size="12px">
                <q-tooltip>
                    Flip Image horizontally
                </q-tooltip>
            </q-btn>
            <q-btn q-btn flat round color="primary" icon="swap_vert" @click="croppa.flipY()" size="12px">
                <q-tooltip>
                    Flip Image vertically
                </q-tooltip>
            </q-btn>
            <q-btn q-btn flat round color="primary" icon="clear" @click="croppa.remove()" size="12px">
                <q-tooltip>
                    Clear Image
                </q-tooltip>
            </q-btn>
        </div>
        <div class="row justify-end q-gutter-md" v-if="!live">
            <slot name="prependButton"></slot>
            <q-btn @click="Output" color="primary">Save</q-btn>
            <slot name="appendButton"></slot>
        </div>
    </div>

</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';

@Component
export default class ImageUploader extends Vue {
    croppa: any = {}
    @Prop() placeholder!: string;
    @Prop() w!: number;
    @Prop() h!: number;
    @Prop() image!: string;
    @Prop() live!: boolean
    @Prop() disableInteraction!: boolean;
    // @Prop() autoRefresh!: boolean;


    // Reload() {
    //     if (this.autoRefresh)
    //         this.croppa.refresh();
    // }
    //
    // @Watch('image')
    // OnImageChange() {
    //     this.Reload();
    // }
    //
    // @Watch('w')
    // OnWChange() {
    //     this.Reload();
    // }
    //
    // @Watch('h')
    // OnHChange() {
    //     this.Reload();
    // }


    GenerateImage(): string {

        return this.croppa.generateDataUrl('image/png', 0.9);
    }

    get Height() {
        return this.w + 'px';
    }

    get Width() {
        return (this.h) + 'px';
    }

    onUpdate() {
        if (this.live) {

            Vue.nextTick(() => {
                const image = this.GenerateImage();
                this.$emit('change', image)
            })
        }
    }

    get ParentStyle() {
        return {
            height: this.Height,
            width: this.Width,
        };
    }

    Output() {
        this.$emit('onSave', this.GenerateImage());
    }
}
</script>
